unit DTUnit;

interface

uses
  Classes, Generics.Collections, IdHashMessageDigest, SysUtils, Winsock2,
  IdHTTP, WinInet, IdException, IdExceptionCore, RegularExpressionsCore,
  {codesitelogging,} ComObj, ActiveX, Variants, DB, Data.Win.ADODB, httpsend,
  synacode, synautil;

const
  REGULAR_EXPRESSION_FACULTY_REF =
    '(?i).*?\d{4}/(.*?)/|(?i).*?\d{4}/(.*?_list)';
  REGULAR_EXPRESSION_STUDENT_REF = '(?i).*?\d{4}/(.*?)/.*?[^@]/';
  // '(?i).*?\d{4}/(.*?)/.*?/';     -
  //     ../YEAR/FACULTY/@@/index.htm

  REGULAR_EXPRESSION_EXTRACT_REFS = '(?s)(?i)<a.+?href\s*?=\s*?(.*?)[\s>]';
  REGULAR_EXPRESSION_EXTRACT_REFS_EXT = // for frames
    '(?s)(?i)<a.+?href\s*?=\s*?(.*?)[\s>]|(?s)(?i)<frame\s*.*?Src\s*=\s*(.*?[\s])\s*.*?';

  ADO_CREATE_STRING = 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=%s';

  ADO_GET_ID_FROM_MD5 = 'SELECT %s FROM %s WHERE %s = "%s"';

  ADO_ADD_YEARS = 'INSERT INTO TYears VALUES ("%d","%s");';
  ADO_ADD_FACULTY =
    'INSERT INTO TFaculties (Faculty_Ref,Year_KOD,Faculty_MD5) VALUES("%s","%s","%s")';
  ADO_ADD_STUDENT =
    'INSERT INTO TStudents (Student_Ref,Year_KOD,Faculty_KOD,Student_MD5)' +
    ' VALUES ("%s","%s","%s","%s");';
  ADO_ADD_REF =
    'INSERT INTO TRefs (Ref, ContentType, Protocol, Status, IsInner, Ref_MD5, StudentName,'
    + ' Department, Chapter, Year_KOD, IsNeedToLoad, ErrorCode, Student_KOD ) VALUES '
    + '(%s "%s");';
  ADO_ADD_CROSS =
    'INSERT INTO TCrossRefs (Source_KOD, Receiver_KOD, Start_KOD) VALUES ("%s", "%s", "%s");';
  ADO_IS_REF_UNUQUE = 'SELECT REF_ID FROM TRefs WHERE Ref_MD5 = "%s";';

  ADO_CONNECTION_STRING =
    'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=%s;Persist Security Info=False;';
  ADO_CREATE_YEARS_TABLE =
    'CREATE TABLE TYears (Year_ID INTEGER NOT NULL CONSTRAINT PrimaryKey  PRIMARY KEY,'
    + ' Year_Ref MEMO NOT NULL);';
  ADO_CREATE_YEARS_TABLE1 =
    'CREATE TABLE TYears (Year_ID INTEGER NOT NULL CONSTRAINT PrimaryKey  PRIMARY KEY,'
    + ' Year_Ref MEMO NOT NULL, Year_MD5 TEXT(32) NOT NULL CONSTRAINT IndexMD5 UNIQUE );';
  ADO_CREATE_FACULTIES_TABLE =
    'CREATE TABLE TFaculties (Faculty_ID COUNTER CONSTRAINT PrimaryKey  PRIMARY KEY,'
    + ' Faculty_Ref MEMO NOT NULL, Year_KOD INTEGER NOT NULL,Faculty_MD5 TEXT(32) NOT NULL'
    + ' CONSTRAINT IndexMD5 UNIQUE, CONSTRAINT fk_Faculty_Year FOREIGN KEY (Year_KOD)  REFERENCES'
    + ' TYears(Year_Id) );';
  ADO_CREATE_STUDENTS_TABLE =
    'CREATE TABLE TStudents (Student_ID COUNTER CONSTRAINT PrimaryKey  PRIMARY KEY,'
    + ' Student_Ref MEMO NOT NULL, Year_KOD INTEGER NOT NULL,Faculty_KOD INTEGER NOT'
    + ' NULL, Student_MD5 TEXT(32) NOT NULL CONSTRAINT IndexMD5 UNIQUE,CONSTRAINT'
    + ' fk_Student_Faculty FOREIGN KEY (Faculty_KOD)  REFERENCES TFaculties(Faculty_Id),'
    + ' CONSTRAINT fk_Student_Year FOREIGN KEY (Year_KOD) REFERENCES TYears(Year_Id) );';
  ADO_CREATE_REFS_TABLE =
    'CREATE TABLE TRefs (Ref_ID COUNTER CONSTRAINT PrimaryKey  PRIMARY KEY, Ref MEMO NOT NULL,'
    + ' ContentType TEXT(50), Protocol TEXT(20), Status INTEGER, IsInner BYTE,'
    + ' Ref_MD5 TEXT(32) NOT NULL CONSTRAINT IndexMD5 UNIQUE, StudentName TEXT(50), Department TEXT(20), Chapter TEXT(150),'
    + ' Year_KOD INTEGER NOT NULL, IsNeedToLoad BYTE,  Student_KOD Integer NOT NULL,'
    + ' ErrorCode integer NOT NULL, CONSTRAINT fk_Ref_Student FOREIGN KEY (Student_KOD)'
    + ' REFERENCES TStudents(Student_ID), CONSTRAINT fk_Ref_Year FOREIGN KEY (Year_KOD)'
    + ' REFERENCES TYears(Year_Id) );';
  ADO_CREATE_CROSSREFS_TABLE =
    'CREATE TABLE TCrossRefs (CrossRef_ID COUNTER CONSTRAINT PrimaryKey  PRIMARY KEY,'
    + ' Source_KOD INTEGER NOT NULL, Receiver_KOD INTEGER NOT NULL, Start_KOD INTEGER NOT NULL, CONSTRAINT fk_Cross_Start'
    + ' FOREIGN KEY (Start_KOD)  REFERENCES TStudents(Student_ID));';

  HTTP_CONNECT_TIMEOUT = 5000;
  HTTP_READ_TIMEOUT = 1000;

  /// //////////////////////////////////////////////////////////////////////////
  CANONICALIZE_BAD_PATHNAME = 1;
  CANONICALIZE_INTERNET_INVALID_URL = 2; // do not change
  CANONICALIZE_INVALID_PARAMETER = 3;
  /// //////////////////////////////////////////////////////////////////////////

  CONNECTION_HTTP = 10;
  CONNECTION_UNKNOWN_PROTOCOL = 11;
  CONNECTION_INDY_GENERAL = 12;
  CONNECTION_GENERAL = 13;
  CONNECTION_CANT_RESOLVE_IP = 14;
  CONNECTION_DO_NOT_NEED_TO_WORK = 15;
  CONNECTION_READ_TIMEOUT = 16;
  CONNECTION_CONNECT_TIMEOUT = 17;
  CONNECTION_SOCKS_UNINIT = 18;

  CONNECTION_ADD_LINK = 19;
  CONNECTION_NOT_ADD_LINK = 20;

  LINK_NAVIGATIONAL_LINK = 21;
  LINK_LINK_IN_DICT = 22;
  LINK_DO_NOT_CHECK = 23;
  LINK_NOT_HTML = 24;

  MesCONNECTION_ADD_LINK = 'CONNECTION_ADD_LINK';
  MesCONNECTION_NOT_ADD_LINK = 'CONNECTION_NOT_ADD_LINK';

  MesCONNECTION_SOCKS_UNINIT = 'CONNECTION_SOCKS_UNINIT';
  MesCONNECTION_READ_TIMEOUT = 'CONNECTION_READ_TIMEOUT';
  MesCONNECTION_CONNECT_TIMEOUT = 'CONNECTION_CONNECT_TIMEOUT';
  MesLINK_LINK_IN_DICT = 'ERROR_LINK_IN_DICT';
  MesCONNECTION_CANT_RESOLVE_IP = 'CANT_RESOLVE_IP';
  MesCONNECTION_DO_NOT_NEED_TO_WORK = 'DO_NOT_NEED_TO_WORK';
  MesCANONICALIZE_BAD_PATHNAME = 'ERR0R_BAD_PATHNAME';
  MesCANONICALIZE_INTERNET_INVALID_URL = 'ERR0R_INTERNET_INVALID_URL';
  MesCANONICALIZE_INVALID_PARAMETER = 'ERR0R_INVALID_PARAMETER';
  MesCONNECTION_HTTP = 'ERROR_HTTP';
  MesCONNECTION_UNKNOWN_PROTOCOL = 'ERROR_UNKNOWN_PROTOCOL';
  MesCONNECTION_INDY_GENERAL = 'ERROR_INDY_GENERAL';
  MesCONNECTION_GENERAL = 'INFOCONNECTION_ERROR_GENERAL';
  MesLINK_NAVIGATIONAL_LINK = 'NAVIGATIONAL_LINK';

  USER_AGENTS: array [0 .. 40] of string =
    ('Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)',
    'Yandex/1.01.001 (compatible; Win16; I)',
    'Mozilla/5.0 (compatible; Yahoo! Slurp; http://help.yahoo.com/help/us/ysearch/slurp)',
    'WebAlta Crawler/1.3.12 (http://www.webalta.ru/bot.html) (Windows; U; Windows NT 5.1; ru-RU)',
    'Aport', 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)',
    'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 1.1.4322)',
    'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)',
    'WebAlta Crawler/1.3.11 (http://www.webalta.ru/bot.html) (Windows; U; Windows NT 5.1; ru-RU)',
    'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)',
    'Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)',
    'TurtleScanner/1.4 (compatible; Win16; S)',
    'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; .NET CLR 1.1.4322)',
    'msnbot/1.0 (+http://search.msn.com/msnbot.htm)',
    'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; InfoPath.1)',
    'msnbot/0.9 (+http://search.msn.com/msnbot.htm)',
    'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; MRA 4.6 (build 01425))',
    'Mozilla/4.0 (compatible; MSIE 6.0; Windows 98)',
    'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0; .NET CLR 1.1.4322)',
    'Mozilla/4.0 (compatible; MSIE 5.0; Windows 98; DigExt)',
    'Mozilla/5.0 (Windows; U; Windows NT 5.1; ru; rv:1.8.0.4) Gecko/20060508 Firefox/1.5.0.4',
    'ConveraCrawler/0.9d (+http://www.authoritativeweb.com/crawl)',
    'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; ru) Opera 8.54',
    'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 1.1.4322; .NET CLR 2.0.50727)',
    'StackRambler/2.0', 'Mozilla/4.0 (compatible; MSIE 5.01; Windows 98)',
    'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 1.1.4322; InfoPath.1)',
    'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; MRA 4.4 (build 01348))',
    'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0; .NET CLR 1.1.4322; .NET CLR 2.0.50727)',
    'Mozilla/5.0 (Windows; U; Windows NT 5.1; ru; rv:1.8.0.3) Gecko/20060426 Firefox/1.5.0.3',
    'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 2.0.50727)',
    'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; MRA 4.4 (build 01334))',
    'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; MRA 4.3 (build 01218))',
    'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; ru) Opera 8.50',
    'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; MyIE2)',
    'Mozilla/4.0 (compatible; MSIE 5.5; Windows 98; Win 9x 4.90)',
    'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; MRA 4.6 (build 01425))',
    'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 1.0.3705; .NET CLR 1.1.4322)',
    'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.2; .NET CLR 1.1.4322)',
    'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; MRA 4.3 (build 01218))',
    'Opera/9.00 (Windows NT 5.1; U; ru)');

var
  MAX_THREADS: Integer = 15;

type
  EDTUnitException = class(Exception);
  ECanonicalizeException = class(EDTUnitException);
  EBadPathName = class(ECanonicalizeException);
  EInvalidUrl = class(ECanonicalizeException);
  EInvalidParameter = class(ECanonicalizeException);
  ECantResolveIP = class(EDTUnitException);
  EDoNotNeedToWork = class(EDTUnitException);
  EErrorHTTP = class(EDTUnitException);
  EUnknownProtocol = class(EDTUnitException);
  EIndyGeneral = class(EDTUnitException);
  ELinkInDictionary = class(EDTUnitException);
  ENavigationalLink = class(EDTUnitException);
  EConnectSocksUnInit = class(EDTUnitException);
  EConnectTimeout = class(EDTUnitException);
  EReadTimeout = class(EDTUnitException);
  EAddLink = class(EDTUnitException);
  ENotAddLink = class(EDTUnitException);
  EGeneral = class(EDTUnitException);
  EDTManagerException = class(EDTUnitException);
  EDTManProblemWithADOX = class(EDTManagerException);

  TDTWorkMode = (wmFullProc, wmOnePage);
  TDTManWorkmode = (wmManGetStudentsToFiles, wmManGetStudentsToDB,
    wmManGetLinksToFile, wmManGetLinksToDb);

  TIPAddress = record
    b1: Byte;
    b2: Byte;
    b3: Byte;
    b4: Byte;
  end;

  TInfoConnection = record
  private
    FURL: string;
    FHost: string;
    FHostIp: TIPAddress;
    FContentType: string;
    FProtocol: string;
    FStatus: Integer;
    FHtml: string;
    FHTTP: TIdHTTP;

    FHTTP1: THTTPSend;

    FIsInner: Boolean;
    procedure SetHost(AHost: string);
    procedure SetFFIP;
    function GetHostIP: string;
    function GetStatus: string;
    function GetIsInner: string;
  public
    property Url: string read FURL;
    property Host: string read FHost write SetHost;
    property HostIP: string read GetHostIP;
    property ContentType: string read FContentType;
    property Protocol: string read FProtocol;
    property Status: string read GetStatus;
    property Html: string read FHtml;
    property IsInner: string read GetIsInner;

    constructor Create1(AURL: string; AIsNeedToLoad: Boolean;
      var AErrorOut: Integer; ADontGet: Boolean); overload;
    constructor Create(AURL: string; AIsNeedToLoad: Boolean;
      var AErrorOut: Integer; ADontGet: Boolean); overload;

  end;

  TInfoMD5 = record
  private
    FCurrent: string;
    FParent: string;
    FStartRef: string;
    procedure SetCurrent(AURL: string);
    procedure SetStartRef(AURL: string);
  public
    property Current: string read FCurrent write SetCurrent;
    property Parent: string read FParent write FParent;
    property StartRef: string read FStartRef write SetStartRef;
    constructor Create(AURL: string; AStart: string; AParent: string = '');
  end;

  TInfoStudent = record
  private
    FName: string;
    FFaculty: string;
    FSection: string;
    FRelYear: string;
    // FIsNeedToLoad: Boolean;
    function GetIsNeedToLoad: string;
  public
    FIsNeedToLoad: Boolean;
    property Name: string read FName write FName;
    property Faculty: string read FFaculty write FFaculty;
    property Section: string read FSection write FSection;
    property RelYear: string read FRelYear write FRelYear;
    property IsNeedToLoad: string read GetIsNeedToLoad;
    constructor Create(AURL, AStartFolder, AStartRef: String);
  end;

  TMD5List = TList<TInfoMD5>;

  PLink = ^TLink;

  TLink = record
  private
    FConnection: TInfoConnection;
    FHashValue: TInfoMD5;
    FStudent: TInfoStudent;
    FErrorCode: Integer;
    function Canonicalize(const ArelUrl, AbaseUrl: string;
      AErrorOut: Integer): string;
    procedure SetErrorCode(AErrorCode: Integer);
    function IsBookmark(AURLin: String; var AUROut: String): Boolean;

  public
    function ToString: string;
    constructor Create(AURL, AStartFolder, AStartRef: string;
      ADictionary: TObject; AMD5list: TMD5List; ACurrentLink: PLink;
      AWorkMode: TDTWorkMode);
    property Connection: TInfoConnection read FConnection;
    property HashValue: TInfoMD5 read FHashValue;
    property Student: TInfoStudent read FStudent;
    property ErrorCode: Integer read FErrorCode write SetErrorCode;
  end;

  TLinkDictionary = TDictionary<string, TLink>;
  TStringQueue = TQueue<string>;

  PDTState = ^TDTState;

  TDTState = record
  private
    FStartRef: string;
    FMyID: Integer;
    FLinksNumber: Integer;
    FLinksWaitNumber: Integer;
    FLinksInHashList: Integer;
  public
    property StartRef: string read FStartRef;
    property MyID: Integer read FMyID;
    property LinksNumber: Integer read FLinksNumber;
    property LinksWaitNumber: Integer read FLinksWaitNumber;
    property LinksInHashList: Integer read FLinksInHashList;
  end;

  TDownloadThread = class(TThread)
  private
    { Private declarations }
    FStartFolder: string;
    FCurrentLink: TLink;
    FRegExpr: TPerlRegEx;
    FLinkDictionary: TLinkDictionary;
    FMD5List: TMD5List;
    FStringQueue: TStringQueue;
    FWorkMode: TDTWorkMode;
    { &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& }
    FDTState: PDTState;
    FNumber: Integer;

    { &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& }
    procedure ExtractRefs;
    procedure SetDTState(AStartRef: string;
      AMyID, ALinksNumber, ALinksWaitNumber, ALinksInHashList: Integer);

  public
    { &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& }
    // procedure IsTerminate(Sender: TObject);

    { &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& }

    property Number: Integer read FNumber;

    constructor Create(ACreateSuspended: Boolean;
      var ALinkDictionary: TLinkDictionary; var AMD5list: TMD5List;
      const AURL: string; ANumber: Integer; { AOnTerminate: TNotifyEvent; }
      ADTState: PDTState; AWorkMode: TDTWorkMode = wmFullProc);
    destructor Destroy; override;

    procedure Execute; override;
  end;

  TDTStates = array of TDTState;

  TDTManState = (dtmsWriteYearsLinkstoDBStart, dtmsWriteYearsLinkstoDBFinish,
    dtmsGetFacsLinksStart, dtmsGetFacsLinksFinish,
    dtmsWriteFacsLinksToFileStart, dtmsWriteFacsLinksToFileFinish,
    dtmsWriteFacsLinksToDbStart, dtmsWriteFacsLinksToDbFinish,
    dtmsGetStudLinksStart, dtmsGetStudLinksFinish,
    dtmsWriteStudLinksToFileStart, dtmsWriteStudLinksToFileFinish,
    dtmsWriteStudLinksToDBStart, dtmsWriteStudLinksToDBFinish,
    dtmsGetLinksStart, dtmsGetLinksFinish, dtmsWriteLinksToFileStart,
    dtmsWriteLinksToFileFinish, dtmsWriteLinksToDBStart,
    dtmsWriteLinksToDBFinish, dtmsCreatingDBStart, dtmsCreatingDBFinish,
    dtmsWaitingForThreadsStart, dtmsWaitingForThreadsFinish,
    dtmsMakeBackupStart, dtmsMakeBackupFinish);

  TDTManagerDTStatesChangeEvent = procedure(ADTState: TDTState) of object;
  TDTManagerStateChangeEvent = procedure(ADTManState: TDTManState;
    AParams: array of const) of object;
  TDTManagerErrorNotifier = procedure(AMes: String) of object;
  TDTLoadToDBNotifier = procedure(ATAble: String; Aall, ACurrent: Integer)
    of object;

  TDTManager = class(TThread)
  private
    FMaxThreads: Integer;

    FRegExprFacultyRef: TPerlRegEx;
    FRegExprStudentRef: TPerlRegEx;

    FWorkMode: TDTManWorkmode;

    FDTStatesCurrent: TDTStates;
    FDTStatesBuffered: TDTStates;

    FErrorLog: TStringList;
    FErrorLogFile: string;

    FFacsRefsList: TStringList;
    FStudRefsList: TStringList;

    FStudRefsRemainList: TStringList;
    FStudRefsProcessedList: TStringList;

    FBigDictionary: TLinkDictionary;
    FBigMD5List: TMD5List;

    FDictionaryArray: array of TLinkDictionary;
    FMD5ListArray: array of TMD5List;
    FDTArray: array of TDownloadThread;

    FFacsFile: string;
    FStudFile: string;

    FStudFileRemain: string;
    FStudFileProcessed: string;
    FErrorNotifier: TDTManagerErrorNotifier;
    FLoadTODbNotifier: TDTLoadToDBNotifier;

    FDBFile: string;
    FInterval: Integer;

    FDTManState: TDTManState;

    FOnDTStatesChange: TDTManagerDTStatesChangeEvent;
    FOnDTManagerStateChangeEvent: TDTManagerStateChangeEvent;
    FADOQuery: TADOquery;
    Ftest: Boolean;
    procedure GetListsOfRefsOnMastersPortal;
    procedure GetData;
    function GetIDFromMD5(AField, ATAble, AMD5Field, AMD5Value,
      ADefault: String): string;
    procedure InitializeDB;
    function IsCorrectFacultyRef(ARef: string): Boolean;
    function IsCorrectStudentRef(ARef: string): Boolean;
    function IsDTStatesChanged(index: Integer): Boolean;
    function GetDocName(AYear: Integer): string;
    procedure WaitForThreads(ACount: Integer);
    procedure SetState(ADTManState: TDTManState);
    procedure AllocateResource(Alength: Integer);
    procedure FreeResource;
    procedure LoadToDB(AInt: Integer); overload;
    procedure LoadToDB(AURL: string; AMD5: TInfoMD5; AYear: Integer); overload;
    function RefIsUnique(AMD5: String): Boolean;
    procedure MakeBAK;
    procedure SendError(AMes: String);
  protected

    procedure Execute; override;

    property State: TDTManState read FDTManState write SetState;
  public
    property DBNotifier: TDTLoadToDBNotifier read FLoadTODbNotifier
      write FLoadTODbNotifier;
    property StudFileProcessed: string read FStudFileProcessed;
    property StudFileRemain: string read FStudFileRemain;
    property ErrorNotifier: TDTManagerErrorNotifier read FErrorNotifier
      write FErrorNotifier;
    property ErrorLogFile: string read FErrorLogFile;
    property OnDTManagerStateChangeEvent: TDTManagerStateChangeEvent
      read FOnDTManagerStateChangeEvent write FOnDTManagerStateChangeEvent;
    property OnDTStatesChange: TDTManagerDTStatesChangeEvent
      read FOnDTStatesChange write FOnDTStatesChange;
    constructor Create(ACreateSuspended: Boolean; AMaxThreads: Integer = 15;
      AInterval: Integer = 500; ADBFile: string = '';
      AFacsFile: string = 'newdb'; AStudFile: string = 'newdb'); overload;
    constructor Create(ACreateSuspended: Boolean; ADBFile: string;
      AMaxThreads: Integer = 15; AInterval: Integer = 500); overload;
    constructor Create(Atest: string = 'test'); overload;
    destructor Destroy; override;
  end;

  { ---------------------------------------------------------------------------- }
function GetBetween(const PairBegin, PairEnd: string; var value: string;
  needtomodify: Boolean): string;
function SeparateRight(const value, Delimiter: string): string;
function SeparateLeft(const value, Delimiter: string): string;
{ ---------------------------------------------------------------------------- }

implementation

{ TDownloadThread }

constructor TDownloadThread.Create(ACreateSuspended: Boolean;
  var ALinkDictionary: TLinkDictionary; var AMD5list: TMD5List;
  const AURL: string; ANumber: Integer; { AOnTerminate: TNotifyEvent; }
  ADTState: PDTState; AWorkMode: TDTWorkMode);
var
  i: Integer;
begin
  inherited Create(ACreateSuspended);
  Self.FWorkMode := AWorkMode;
  { &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& }

  Self.FDTState := ADTState;
  Self.FDTState^.FStartRef := AURL;
  Self.FDTState^.FMyID := ANumber;
  Self.FDTState^.FLinksWaitNumber := 1;

  { &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& }

  FreeOnTerminate := true;
  i := LastDelimiter('/', AURL);
  FStartFolder := Copy(AURL, 1, i);
  FLinkDictionary := ALinkDictionary;
  FMD5List := AMD5list;
  FStringQueue := TStringQueue.Create;
  FRegExpr := TPerlRegEx.Create;
  FRegExpr.RegEx := REGULAR_EXPRESSION_EXTRACT_REFS_EXT;
  FRegExpr.Options := [preMultiLine, preExtended];
  FRegExpr.Study;
  FCurrentLink := TLink.Create(AURL, FStartFolder, AURL, FLinkDictionary,
    FMD5List, nil, AWorkMode);

end;

destructor TDownloadThread.Destroy;
begin
  Self.FRegExpr.Free;
  Self.FStringQueue.Free;
  inherited Destroy;
end;

procedure TDownloadThread.Execute;
begin
  ExtractRefs;
  // if Self.FWorkMode = wmOnePage then
  FLinkDictionary.Remove(FCurrentLink.FHashValue.FCurrent);
  while FStringQueue.Count > 0 do
  begin
    with Self.FDTState^ do
      Self.SetDTState(FStartRef, FMyID, FLinkDictionary.Count,
        FStringQueue.Count, Self.FMD5List.Count);
    FLinkDictionary.TryGetValue(FStringQueue.Dequeue, FCurrentLink);

    ExtractRefs;
  end;
  with Self.FDTState^ do
    Self.SetDTState(FStartRef, FMyID, FLinkDictionary.Count, FStringQueue.Count,
      Self.FMD5List.Count);
  { CodeSite.Send('   ' + inttostr(CurrentThread.ThreadID),
    Self.FLinkDictionary.Count);
    CodeSite.Send('   ' + inttostr(CurrentThread.ThreadID),
    Self.FMD5List.Count);
  }
  { Place thread code here }
end;

procedure TDownloadThread.ExtractRefs;
var
  buf: string;
  bufLink: TLink;
  i: Integer;

begin
  { -------------------------------------------------------------------------- }
  try
    with FRegExpr do
    begin
      Subject := FCurrentLink.Connection.Html;
      if Match then
      begin
        repeat
          for i := 1 to 2 do
          begin
            if (Pos('http://www.topping.com.ua/', Groups[i]) <> 0) or
              (Pos('http://www.bigmir.net/?cl=38404', Groups[i]) <> 0) or
              (Pos('http://top100.rambler.ru/top100/', Groups[i]) <> 0) or
              (Pos('http://top.mail.ru/jump?from=407990', Groups[i]) <> 0) or
              (Pos('http://rating.openstat.ru/?cid=2124156', Groups[i]) <> 0) or
              (Length(Groups[i]) = 0) then
              Continue;
            if Terminated then
            begin
              FStringQueue.Clear;
              Exit;
            end;
            buf := StringReplace(Groups[i], '"', '',
              [rfReplaceAll, rfIgnoreCase]);
            buf := StringReplace(buf, '''', '', [rfReplaceAll, rfIgnoreCase]);
            { CodeSite.SendWarning(' ' +
              inttostr(CurrentThread.ThreadID) + buf); }
            bufLink := TLink.Create(buf, FStartFolder, Self.FDTState^.FStartRef,
              FLinkDictionary, FMD5List, @FCurrentLink, Self.FWorkMode);
            if bufLink.ErrorCode = 0 then
            begin
              FStringQueue.Enqueue(bufLink.HashValue.Current);
              with Self.FDTState^ do
                Self.SetDTState(FStartRef, FMyID, FLinkDictionary.Count,
                  FStringQueue.Count, Self.FMD5List.Count);
              { CodeSite.Send('    ' +
                inttostr(CurrentThread.ThreadID) + bufLink.Connection.Url); }
            end;
          end;
        until not MatchAgain;
      end;
      Subject := '';
    end;
  except
    { on E: Exception do
      CodeSite.SendError(E.Message + ' ' + E.ClassName + ' Id= ' +
      inttostr(CurrentThread.ThreadID)); }
  end;
  { -------------------------------------------------------------------------- }
end;

procedure TDownloadThread.SetDTState(AStartRef: string;
  AMyID, ALinksNumber, ALinksWaitNumber: Integer; ALinksInHashList: Integer);
begin
  with Self.FDTState^ do
  begin
    FStartRef := AStartRef;
    FMyID := AMyID;
    FLinksNumber := ALinksNumber;
    FLinksWaitNumber := ALinksWaitNumber;
    FLinksInHashList := ALinksInHashList
  end;
end;

{ TInfoMD5 }

constructor TInfoMD5.Create(AURL, AStart, AParent: string);
begin
  Self.Parent := AParent;
  Self.Current := AURL;
  Self.StartRef := AStart
end;

procedure TInfoMD5.SetCurrent(AURL: string);
var
  MesDig: TIdHashMessageDigest5;
begin
  MesDig := TIdHashMessageDigest5.Create;
  Self.FCurrent := MesDig.HashStringAsHex(AURL);
  MesDig.Free;
end;

procedure TInfoMD5.SetStartRef(AURL: string);
var
  MesDig: TIdHashMessageDigest5;
begin
  MesDig := TIdHashMessageDigest5.Create;
  Self.FStartRef := MesDig.HashStringAsHex(AURL);
  MesDig.Free;
end;

{ TInfoStudent }

constructor TInfoStudent.Create(AURL, AStartFolder, AStartRef: String);
var
  position: Integer;
  bufurl: string;
begin
  Self.FIsNeedToLoad := (Pos(AStartFolder, AURL) > 0);
  if not Self.FIsNeedToLoad then
    bufurl := AStartRef
  else
    bufurl := AURL;

  position := Pos('://', bufurl);
  Delete(bufurl, 1, position + 2);
  position := Pos('/', bufurl);
  Delete(bufurl, 1, position - 1);

  Self.FRelYear := GetBetween('/', '/', bufurl, true);
  Self.FFaculty := GetBetween('/', '/', bufurl, true);
  Self.FName := GetBetween('/', '/', bufurl, true);
  Self.FSection := GetBetween('/', '/', bufurl, true);
end;

function GetBetween(const PairBegin, PairEnd: string; var value: string;
  needtomodify: Boolean): string;
var
  n: Integer;
  x: Integer;
  s: string;
  lenBegin: Integer;
  lenEnd: Integer;
  str: string;
  max: Integer;
begin
  lenBegin := Length(PairBegin);
  lenEnd := Length(PairEnd);
  n := Length(value);
  if (value = PairBegin + PairEnd) then
  begin
    Result := '';
    // nothing between
    Exit;
  end;
  if (n < lenBegin + lenEnd) then
  begin
    Result := value;
    Exit;
  end;
  s := SeparateRight(value, PairBegin);
  if (s = value) then
  begin
    Result := value;
    Exit;
  end;
  n := Pos(PairEnd, s);
  if (n = 0) then
  begin
    Result := value;
    Exit;
  end;
  Result := '';
  x := 1;
  max := Length(s) - lenEnd + 1;
  for n := 1 to max do
  begin
    str := Copy(s, n, lenEnd);
    if (str = PairEnd) then
    begin
      Dec(x);
      if (x <= 0) then
        Break;
    end;
    str := Copy(s, n, lenBegin);
    if (str = PairBegin) then
      inc(x);
    Result := Result + s[n];
  end;
  if needtomodify then
    value := StringReplace(s, Result, '', [rfReplaceAll, rfIgnoreCase]);
end;

function SeparateLeft(const value, Delimiter: string): string;
var
  x: Integer;
begin
  x := Pos(Delimiter, value);
  if x < 1 then
    Result := value
  else
    Result := Copy(value, 1, x - 1);
end;

function SeparateRight(const value, Delimiter: string): string;
var
  x: Integer;
begin
  x := Pos(Delimiter, value);
  if x > 0 then
    x := x + Length(Delimiter) - 1;
  Result := Copy(value, x + 1, Length(value) - x);
end;

function TInfoStudent.GetIsNeedToLoad: string;
begin
  if FIsNeedToLoad then
    Exit('255')
  else
    Exit('0');
end;

{ TInfoConnection }

constructor TInfoConnection.Create(AURL: string; AIsNeedToLoad: Boolean;
  var AErrorOut: Integer; ADontGet: Boolean);
var
  UserName, pass, port, path, para, hst, buf: string;
  bufbool: Boolean;
  bufstrings: TStringList;
begin
  Self.FURL := AURL;
  Self.FHTTP1 := THTTPSend.Create;
  try
    try
      buf := ParseURL(AURL, Self.FProtocol, UserName, pass, hst, port,
        path, para);
      Self.Host := hst;
      Self.FIsInner := Pos('194:44:183:', Self.HostIP) > 0;
      if ADontGet then
      begin
        AErrorOut := CONNECTION_NOT_ADD_LINK;
        if Self.FIsInner then
          if AIsNeedToLoad then
            AErrorOut := CONNECTION_ADD_LINK;
        Exit;
      end;
      with Self.FHTTP1 do
      begin
        // ReadTimeout := HTTP_READ_TIMEOUT;
        Timeout := HTTP_CONNECT_TIMEOUT;
        UserAgent := USER_AGENTS[Random(40)];
      end;
      /// //////////////////////////////////////////////////////////////
      if Self.HostIP = '255:255:255:255' then
      begin
        AErrorOut := CONNECTION_CANT_RESOLVE_IP;
        Exit;
      end;
      if LowerCase(Self.Protocol) <> 'http' then
      begin
        AErrorOut := CONNECTION_UNKNOWN_PROTOCOL;
        Exit
      end;
      bufbool := FHTTP1.HTTPMethod('HEAD', Self.Url);
      if not bufbool then
        raise EGeneral.Create('Error Message');
      Self.FContentType := FHTTP1.MimeType;
      Self.FStatus := FHTTP1.ResultCode;
      if (Self.FStatus < 200) or (Self.FStatus >= 300) then
        raise EIdHTTPProtocolException.CreateError(Self.FStatus,
          FHTTP1.ResultString, 'sdasd');
      case AIsNeedToLoad of
        true:
          begin
            if (Pos('text', Self.ContentType) > 0) then
            begin
              FHTTP1.Clear;
              bufbool := FHTTP1.HTTPMethod('GET', Self.Url);
              if not bufbool then
                raise EGeneral.Create('Error Message');
              bufstrings := TStringList.Create;
              bufstrings.LoadFromStream(FHTTP1.Document);
              FHtml := bufstrings.Text;
              bufstrings.Free;
              AErrorOut := 0;
            end
            else
              AErrorOut := LINK_NOT_HTML;
          end;
        False:
          begin
            if Self.FIsInner then
              AErrorOut := CONNECTION_DO_NOT_NEED_TO_WORK
            else
              AErrorOut := LINK_DO_NOT_CHECK;
          end;
      end;
    except
      on E: EIdHTTPProtocolException do
      begin
        Self.FStatus := E.ErrorCode;
        AErrorOut := CONNECTION_HTTP;
      end;
      on E: EidReadtimeout do
      begin
        AErrorOut := CONNECTION_READ_TIMEOUT;
      end;
      on E: EIdConnectTimeout do
      begin
        AErrorOut := CONNECTION_CONNECT_TIMEOUT;
      end;
      on E: EIdUnknownProtocol do
        AErrorOut := CONNECTION_UNKNOWN_PROTOCOL;
      on E: EidException do
      begin
        case (E.ClassNameIs('EIdSocketError') and
          (Pos('Socket Error # 10093', E.Message) > 0)) of
          true:
            AErrorOut := CONNECTION_SOCKS_UNINIT;
          False:
            AErrorOut := CONNECTION_INDY_GENERAL;
        end;
        { CodeSite.SendException(E); }
      end;
      on E: EGeneral do
      begin
        { CodeSite.SendException(E); }
        AErrorOut := CONNECTION_GENERAL;
      end;
      on E: Exception do
      begin
        { CodeSite.SendException(E); }
        AErrorOut := CONNECTION_GENERAL;
      end;
    end;
  finally
    FreeAndNil(Self.FHTTP1);
  end;
end;

constructor TInfoConnection.Create1(AURL: string; AIsNeedToLoad: Boolean;
  var AErrorOut: Integer; ADontGet: Boolean);
begin
  try
    try
      Self.FURL := AURL;
      Self.FHTTP := TIdHTTP.Create(nil);
      Self.FHTTP.Url.Create(AURL);
      Self.Host := Self.FHTTP.Url.Host;
      Self.FIsInner := Pos('194:44:183:', Self.HostIP) > 0;
      Self.FProtocol := FHTTP.Url.Protocol;
      if ADontGet then
      begin
        AErrorOut := CONNECTION_NOT_ADD_LINK;
        if Self.FIsInner then
          if AIsNeedToLoad then
            AErrorOut := CONNECTION_ADD_LINK;
        Exit;
      end;
      with Self.FHTTP do
      begin
        ReadTimeout := HTTP_READ_TIMEOUT;
        ConnectTimeout := HTTP_CONNECT_TIMEOUT;
        Request.UserAgent := USER_AGENTS[Random(40)];
        Request.Accept := '*/*';
        HandleRedirects := False;

      end;

      /// //////////////////////////////////////////////////////////////
      if Self.HostIP = '255:255:255:255' then
      begin
        AErrorOut := CONNECTION_CANT_RESOLVE_IP;
        Exit;
      end;
      if LowerCase(FHTTP.Url.Protocol) <> 'http' then
      begin
        AErrorOut := CONNECTION_UNKNOWN_PROTOCOL;
        Exit
      end;
      FHTTP.Head(Self.Url);
      Self.FContentType := FHTTP.Response.ContentType;
      Self.FStatus := FHTTP.Response.ResponseCode;
      case AIsNeedToLoad of
        true:
          begin
            if (Pos('text', Self.ContentType) > 0) then
            begin
              Self.FHtml := FHTTP.Get(Self.Url);
              AErrorOut := 0;
            end
            else
              AErrorOut := LINK_NOT_HTML;
          end;
        False:
          begin
            if Self.FIsInner then
              AErrorOut := CONNECTION_DO_NOT_NEED_TO_WORK
            else
              AErrorOut := LINK_DO_NOT_CHECK;
          end;
      end;
    except
      on E: EIdHTTPProtocolException do
      begin
        Self.FStatus := E.ErrorCode;
        AErrorOut := CONNECTION_HTTP;
      end;
      on E: EidReadtimeout do
      begin
        AErrorOut := CONNECTION_READ_TIMEOUT;
      end;
      on E: EIdConnectTimeout do
      begin
        AErrorOut := CONNECTION_CONNECT_TIMEOUT;
      end;
      on E: EIdUnknownProtocol do
        AErrorOut := CONNECTION_UNKNOWN_PROTOCOL;
      on E: EidException do
      begin
        case (E.ClassNameIs('EIdSocketError') and
          (Pos('Socket Error # 10093', E.Message) > 0)) of
          true:
            AErrorOut := CONNECTION_SOCKS_UNINIT;
          False:
            AErrorOut := CONNECTION_INDY_GENERAL;
        end;
        { CodeSite.SendException(E); }
      end;
      on E: Exception do
      begin
        { CodeSite.SendException(E); }
        AErrorOut := CONNECTION_GENERAL;
      end;
    end;
  finally
    FreeAndNil(Self.FHTTP);
  end;
end;

function TInfoConnection.GetHostIP: string;
begin
  Result := Format('%d:%d:%d:%d', [Self.FHostIp.b1, Self.FHostIp.b2,
    Self.FHostIp.b3, Self.FHostIp.b4]);
end;

function TInfoConnection.GetIsInner: string;
begin
  if FIsInner then
    Exit('255')
  else
    Exit('0');
end;

function TInfoConnection.GetStatus: string;
begin
  Result := inttostr(Self.FStatus);
end;

procedure TInfoConnection.SetFFIP;
begin
  Self.FHostIp.b1 := Byte(255);
  Self.FHostIp.b2 := Byte(255);
  Self.FHostIp.b3 := Byte(255);
  Self.FHostIp.b4 := Byte(255);
end;

procedure TInfoConnection.SetHost(AHost: string);
var
  hostname: array [0 .. 255] of AnsiChar;
  HostEnt: PHostEnt;
  addr: PAnsiChar;
  WSADATA: TWSAData;
begin
  { CodeSite.SendNote(' IP ' + AHost); }
  HostEnt := nil;
  Self.FHost := AHost;

  if Self.FHost = 'masters.donntu.edu.ua' then
  begin
    Self.FHostIp.b1 := Byte(194);
    Self.FHostIp.b2 := Byte(44);
    Self.FHostIp.b3 := Byte(183);
    Self.FHostIp.b4 := Byte(11);
    Exit;
  end;
  WSAStartup($101, WSADATA);
  try
    gethostname(hostname, sizeof(hostname));
    StrPCopy(hostname, AnsiString(Self.FHost));
    HostEnt := gethostbyname(hostname);
    if Assigned(HostEnt) then
      if Assigned(HostEnt^.h_addr_list) then
      begin
        addr := HostEnt^.h_addr_list^;
        if Assigned(addr) then
        begin
          Self.FHostIp.b1 := Byte(addr[0]);
          Self.FHostIp.b2 := Byte(addr[1]);
          Self.FHostIp.b3 := Byte(addr[2]);
          Self.FHostIp.b4 := Byte(addr[3]);
        end
        else
          Self.SetFFIP;
      end
      else
        Self.SetFFIP
    else
      Self.SetFFIP;
  finally
    WSACleanup;
    { CodeSite.SendNote('IP ' + Self.HostIP); }
  end;

end;

{ TLink }

constructor TLink.Create(AURL, AStartFolder, AStartRef: string;
  ADictionary: TObject; AMD5list: TMD5List; ACurrentLink: PLink;
  AWorkMode: TDTWorkMode);
var
  bufUrl1, bufUrl2: string;
  bufDict: TLinkDictionary;
  bufIsBookmark: Boolean;
  bufErrorCode: Integer;
begin
  try
    bufIsBookmark := Self.IsBookmark(AURL, bufUrl2);
    bufDict := (ADictionary as TLinkDictionary);
    case Assigned(ACurrentLink) of
      true:
        begin
          bufUrl1 := Canonicalize(bufUrl2, ACurrentLink^.Connection.Url,
            Self.ErrorCode);
          Self.FHashValue := TInfoMD5.Create(bufUrl1, AStartRef,
            ACurrentLink^.FHashValue.Current);
        end;
      False:
        begin
          bufUrl1 := Canonicalize(bufUrl2, '', Self.ErrorCode);
          Self.FHashValue := TInfoMD5.Create(bufUrl1, AStartRef, '');
        end;
    end;
    case bufDict.ContainsKey(Self.HashValue.Current) of
      true:
        begin
          if bufIsBookmark then
            Self.ErrorCode := LINK_NAVIGATIONAL_LINK
          else
            Self.ErrorCode := LINK_LINK_IN_DICT;
        end;
      False:
        begin
          Self.FStudent := TInfoStudent.Create(bufUrl1, AStartFolder,
            AStartRef);
          { CodeSite.SendNote(bufUrl1); }
          if (AWorkMode = wmOnePage) and Assigned(ACurrentLink) then
          begin
            Self.FConnection := TInfoConnection.Create(bufUrl1,
              Self.Student.FIsNeedToLoad, bufErrorCode, true);
            Self.ErrorCode := bufErrorCode;
          end
          else
          begin
            Self.FConnection := TInfoConnection.Create(bufUrl1,
              Self.Student.FIsNeedToLoad, bufErrorCode, False);
            Self.ErrorCode := bufErrorCode;
          end;
          bufDict.Add(Self.HashValue.Current, Self);
          AMD5list.Add(Self.HashValue);
        end;
    end;

  except
    on E: ECanonicalizeException do
    begin
      { CodeSite.SendException(E); }
      // Self.ErrorCode:=LINK_WAS_NOT_PROCESSED;
    end;
    on E: ECantResolveIP do
    begin
      { CodeSite.SendException(E); }
      bufDict.Add(Self.HashValue.Current, Self);
      AMD5list.Add(Self.HashValue);
    end;
    on E: EDoNotNeedToWork do
    begin
      { CodeSite.SendException(E); }
      // Self.ErrorCode:=LINK_WAS_NOT_PROCESSED;
    end;
    on E: EErrorHTTP do
    begin
      { CodeSite.SendException(E); }
      bufDict.Add(Self.HashValue.Current, Self);
      AMD5list.Add(Self.HashValue);
    end;
    on E: EUnknownProtocol do
    begin
      bufDict.Add(Self.HashValue.Current, Self);
      AMD5list.Add(Self.HashValue);
      { CodeSite.SendException(E); }
    end;
    on E: EIndyGeneral do
    begin
      bufDict.Add(Self.HashValue.Current, Self);
      AMD5list.Add(Self.HashValue);
      { CodeSite.SendException(E); }
    end;
    on E: ELinkInDictionary do
    begin
      AMD5list.Add(Self.HashValue);
      { CodeSite.SendException(E); }
    end;
    on E: ENavigationalLink do
    begin
      // AMD5list.Add(Self.HashValue);
      { CodeSite.SendException(E); }
    end;
    on E: EReadTimeout do
    begin
      bufDict.Add(Self.HashValue.Current, Self);
      AMD5list.Add(Self.HashValue);
      { CodeSite.SendException(E); }
    end;
    on E: EConnectTimeout do
    begin
      bufDict.Add(Self.HashValue.Current, Self);
      AMD5list.Add(Self.HashValue);
      { CodeSite.SendException(E); }
    end;
    on E: EGeneral do
    begin
      { CodeSite.SendException(E); }
    end;
    on E: EConnectSocksUnInit do
    begin
      { CodeSite.SendException(E); }
    end;
    on E: EAddLink do
    begin
      bufDict.Add(Self.HashValue.Current, Self);
      AMD5list.Add(Self.HashValue);
      { CodeSite.SendException(E); }
    end;
    on E: ENotAddLink do
    begin
      // bufDict.Add(Self.HashValue.Current, Self);
      // AMD5list.Add(Self.HashValue);
      { CodeSite.SendException(E); }
    end;
  end;
end;

function TLink.IsBookmark(AURLin: String; var AUROut: String): Boolean;
var
  i: Integer;
begin
  i := LastDelimiter('#', AURLin);
  if i > 0 then
  begin
    AUROut := Copy(AURLin, 1, i - 1);
    Exit(true);
  end;
  AUROut := AURLin;
  Exit(False);
end;

function TLink.Canonicalize(const ArelUrl, AbaseUrl: string;
  AErrorOut: Integer): string;
var
  reslength: Cardinal;
begin
  try
    reslength := INTERNET_MAX_URL_LENGTH;
    SetLength(Result, reslength);
    AErrorOut := 0;
    if not InternetCombineUrl(pchar(AbaseUrl), pchar(ArelUrl), pchar(Result),
      reslength, ICU_BROWSER_MODE) then
      case GetLastError of
        { ERROR_BAD_PATHNAME }
        161:
          AErrorOut := CANONICALIZE_BAD_PATHNAME;
        ERROR_INTERNET_INVALID_URL:
          AErrorOut := CANONICALIZE_INTERNET_INVALID_URL;
        { ERROR_INVALID_PARAMETER }
        87:
          AErrorOut := CANONICALIZE_INVALID_PARAMETER;
      end;

  finally
    SetLength(Result, reslength);
  end;

end;

procedure TLink.SetErrorCode(AErrorCode: Integer);
begin
  FErrorCode := AErrorCode;
  case Self.ErrorCode of
    CONNECTION_CANT_RESOLVE_IP:
      raise ECantResolveIP.Create(MesCONNECTION_CANT_RESOLVE_IP);
    CONNECTION_DO_NOT_NEED_TO_WORK:
      raise EDoNotNeedToWork.Create(MesCONNECTION_DO_NOT_NEED_TO_WORK);
    CANONICALIZE_BAD_PATHNAME:
      raise EBadPathName.Create(MesCANONICALIZE_BAD_PATHNAME);
    CANONICALIZE_INTERNET_INVALID_URL:
      raise EInvalidUrl.Create(MesCANONICALIZE_INTERNET_INVALID_URL);
    CANONICALIZE_INVALID_PARAMETER:
      raise EInvalidParameter.Create(MesCANONICALIZE_INVALID_PARAMETER);
    CONNECTION_HTTP:
      raise EErrorHTTP.Create(MesCONNECTION_HTTP);
    CONNECTION_UNKNOWN_PROTOCOL:
      raise EUnknownProtocol.Create(MesCONNECTION_UNKNOWN_PROTOCOL);
    CONNECTION_INDY_GENERAL:
      raise EIndyGeneral.Create(MesCONNECTION_INDY_GENERAL);
    LINK_LINK_IN_DICT:
      raise ELinkInDictionary.Create(MesLINK_LINK_IN_DICT);
    LINK_NAVIGATIONAL_LINK:
      raise ENavigationalLink.Create(MesLINK_NAVIGATIONAL_LINK);
    CONNECTION_GENERAL:
      raise EGeneral.Create(MesCONNECTION_GENERAL);
    CONNECTION_READ_TIMEOUT:
      raise EReadTimeout.Create(MesCONNECTION_READ_TIMEOUT);
    CONNECTION_CONNECT_TIMEOUT:
      raise EConnectTimeout.Create(MesCONNECTION_CONNECT_TIMEOUT);
    CONNECTION_SOCKS_UNINIT:
      raise EConnectSocksUnInit.Create(MesCONNECTION_SOCKS_UNINIT);
    CONNECTION_ADD_LINK:
      raise EAddLink.Create(MesCONNECTION_ADD_LINK);
    CONNECTION_NOT_ADD_LINK:
      raise ENotAddLink.Create(MesCONNECTION_NOT_ADD_LINK);
  end;
end;

function TLink.ToString: string;
var
  declString: string;
  implString: string;
begin
  declString := '(Ref, ';
  implString := 'VALUES ("' + Self.FConnection.Url + '", "';
  if Self.Connection.ContentType <> '' then
  begin
    declString := declString + 'Contenttype, ';
    implString := implString + Self.Connection.ContentType + '", "';
  end;
  if Self.Connection.Protocol <> '' then
  begin
    declString := declString + 'Protocol, ';
    implString := implString + Self.Connection.Protocol + '", "';
  end;
  if Self.Connection.Status <> '' then
  begin
    declString := declString + 'Status, ';
    implString := implString + Self.Connection.Status + '", "';
  end;
  declString := declString +
    'IsInner, Ref_MD5, StudentName, Department, Chapter, Year_KOD, IsNeedToLoad,'
    + 'ErrorCode, Student_KOD )';
  implString := implString + Self.Connection.IsInner + '", "' +
    Self.HashValue.Current + '", "' + Self.Student.Name + '", "' +
    Self.Student.Faculty + '", "' + Self.Student.Section + '", "' +
    Self.Student.RelYear + '", "' + Self.Student.IsNeedToLoad + '", "' +
    inttostr(Self.ErrorCode) + '",';
  implString := StringReplace(implString, '%', '%%',
    [rfReplaceAll, rfIgnoreCase]) + ' "%s");';
  Result := 'INSERT INTO TRefs ' + declString + implString;

  // case Self.ErrorCode of
  // LINK_DO_NOT_CHECK, LINK_NOT_HTML, 0:
  // begin
  // Result := Format
  // (' "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", ',
  // [Self.Connection.Url, Self.Connection.ContentType,
  // Self.Connection.Protocol, Self.Connection.Status,
  // Self.Connection.IsInner, Self.HashValue.Current, Self.Student.Name,
  // Self.Student.Faculty, Self.Student.Section, Self.Student.RelYear,
  // Self.Student.IsNeedToLoad, inttostr(Self.ErrorCode)]);
  // end;
  // CONNECTION_HTTP:
  // begin
  // Result := Format
  // (' "%s", "blank", "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", ',
  // [Self.Connection.Url, Self.Connection.Protocol,
  // Self.Connection.Status, Self.Connection.IsInner,
  // Self.HashValue.Current, Self.Student.Name, Self.Student.Faculty,
  // Self.Student.Section, Self.Student.RelYear,
  // Self.Student.IsNeedToLoad, inttostr(Self.ErrorCode)]);
  // end;
  // CONNECTION_READ_TIMEOUT, CONNECTION_CONNECT_TIMEOUT:
  // begin
  // Result := Format
  // (' "%s", "blank", "%s", "-1", "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", ',
  // [Self.Connection.Url, Self.Connection.Protocol,
  // Self.Connection.IsInner, Self.HashValue.Current, Self.Student.Name,
  // Self.Student.Faculty, Self.Student.Section, Self.Student.RelYear,
  // Self.Student.IsNeedToLoad, inttostr(Self.ErrorCode)]);
  // end;
  // // CONNECTION_HTTP:
  // // begin
  // // Result := Format
  // // (' "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", ',
  // // [Self.Connection.Url, Self.Connection.ContentType,
  // // Self.Connection.Protocol, Self.Connection.Status,
  // // Self.Connection.IsInner, Self.HashValue.Current, Self.Student.Name,
  // // Self.Student.Faculty, Self.Student.Section, Self.Student.RelYear,
  // // Self.Student.IsNeedToLoad]);
  // // end;
  // CONNECTION_UNKNOWN_PROTOCOL:
  // begin
  // Result := Format
  // (' "%s", "blank", "%s", "-1", "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", ',
  // [Self.Connection.Url, Self.Connection.Protocol,
  // Self.Connection.IsInner, Self.HashValue.Current, Self.Student.Name,
  // Self.Student.Faculty, Self.Student.Section, Self.Student.RelYear,
  // Self.Student.IsNeedToLoad, inttostr(Self.ErrorCode)]);
  // end;
  // end;
end;

{ TDTManager }

procedure TDTManager.AllocateResource(Alength: Integer);
begin
  SetLength(FDictionaryArray, Alength);
  SetLength(FMD5ListArray, Alength);
  SetLength(FDTArray, Alength);
  SetLength(FDTStatesCurrent, Alength);
  SetLength(FDTStatesBuffered, Alength);
end;

constructor TDTManager.Create(ACreateSuspended: Boolean; AMaxThreads: Integer;
  AInterval: Integer; ADBFile: string; AFacsFile: string; AStudFile: string);
begin
  inherited Create(ACreateSuspended);
  FRegExprFacultyRef := TPerlRegEx.Create;
  FRegExprStudentRef := TPerlRegEx.Create;
  FreeOnTerminate := true;
  FMaxThreads := AMaxThreads;
  FInterval := AInterval;
  FDBFile := ADBFile + '.mdb';
  if FDBFile = '.mdb' then
  begin
    Self.FWorkMode := wmManGetStudentsToFiles;
    Self.FStudFile := AStudFile + '.students';
    Self.FFacsFile := AFacsFile + '.facs';
  end
  else
  begin
    Self.FStudFile := ADBFile + '.students';
    Self.FFacsFile := ADBFile + '.facs';
    Self.FWorkMode := wmManGetStudentsToDB;
    Self.FADOQuery := TADOquery.Create(nil);
  end;

  with FRegExprFacultyRef do
  begin
    RegEx := REGULAR_EXPRESSION_FACULTY_REF;
    Options := [preMultiLine, preExtended];
    Study;
  end;
  with FRegExprStudentRef do
  begin
    RegEx := REGULAR_EXPRESSION_STUDENT_REF;
    Options := [preMultiLine, preExtended];
    Study;
  end;

end;

procedure TDTManager.MakeBAK;
var
  fsdbs, fsfrs, fsfps, fsels: TFileStream;
  fsdbt, fsfrt, fsfpt, fselt: TFileStream;
begin
  Self.State := dtmsMakeBackupStart;
  FADOQuery.Close;
  FADOQuery.ConnectionString := '';
  deleteFile(FDBFile + '.BAK');
  deleteFile(FStudFileRemain + '.BAK');
  deleteFile(FStudFileProcessed + '.BAK');
  deleteFile(FErrorLogFile + '.BAK');

  fsdbs := TFileStream.Create(FDBFile, fmOpenRead);
  fsfrs := TFileStream.Create(FStudFileRemain, fmOpenRead);
  fsfps := TFileStream.Create(FStudFileProcessed, fmOpenRead);
  fsels := TFileStream.Create(FErrorLogFile, fmOpenRead);
  try
    fsdbt := TFileStream.Create(FDBFile + '.BAK', fmCreate);
    fsfrt := TFileStream.Create(FStudFileRemain + '.BAK', fmCreate);
    fsfpt := TFileStream.Create(FStudFileProcessed + '.BAK', fmCreate);
    fselt := TFileStream.Create(FErrorLogFile + '.BAK', fmCreate);
    try
      fsdbt.CopyFrom(fsdbs, fsdbs.Size);
      fsfrt.CopyFrom(fsfrs, fsfrs.Size);
      fsfpt.CopyFrom(fsfps, fsfps.Size);
      fselt.CopyFrom(fsels, fsels.Size);
    finally
      fsdbt.Free;
      fsfrt.Free;
      fsfpt.Free;
      fselt.Free;
    end;
  finally
    fsdbs.Free;
    fsfrs.Free;
    fsfps.Free;
    fsels.Free;
    FADOQuery.ConnectionString := Format(ADO_CONNECTION_STRING, [FDBFile]);
    Self.State := dtmsMakeBackupFinish;
  end;

end;

constructor TDTManager.Create(ACreateSuspended: Boolean; ADBFile: string;
  AMaxThreads, AInterval: Integer);
var
  bufstringlist: TStringList;
begin
  inherited Create(ACreateSuspended);
  FreeOnTerminate := true;
  Self.FWorkMode := wmManGetLinksToDb;
  Self.FDBFile := ADBFile + '.mdb';
  FMaxThreads := AMaxThreads;
  FInterval := AInterval;
  FStudFile := ADBFile + '.students';
  FStudFileRemain := ADBFile + '.rem';
  FStudFileProcessed := ADBFile + '.proc';
  FErrorLogFile := ADBFile + '.log';

  FStudRefsRemainList := TStringList.Create;
  FStudRefsProcessedList := TStringList.Create;
  FErrorLog := TStringList.Create;

  FStudRefsRemainList.Sorted := true;
  FStudRefsProcessedList.Sorted := true;

  if FileExists(FErrorLogFile) then
    FErrorLog.LoadFromFile(FErrorLogFile);

  if FileExists(FStudFileRemain) then
    FStudRefsRemainList.LoadFromFile(FStudFileRemain)
  else
    FStudRefsRemainList.LoadFromFile(FStudFile);

  if FileExists(FStudFileProcessed) then
    FStudRefsProcessedList.LoadFromFile(FStudFileProcessed);
  FStudRefsRemainList.SaveToFile(FStudFileRemain);
  FStudRefsProcessedList.SaveToFile(FStudFileProcessed);
  FErrorLog.SaveToFile(FErrorLogFile);
end;

constructor TDTManager.Create(Atest: string);
begin
  inherited Create(true);
  Ftest := true;
end;

destructor TDTManager.Destroy;

begin
  if FWorkMode in [wmManGetStudentsToFiles, wmManGetStudentsToDB] then
  begin
    FreeAndNil(FRegExprFacultyRef);
    FreeAndNil(FRegExprStudentRef);
    Self.FDTStatesCurrent := nil;
    Self.FDTStatesBuffered := nil;
  end;
  if FWorkMode <> wmManGetStudentsToFiles then
  begin

    { CodeSite.SendError('LLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLL'); }
    Self.FADOQuery.Free;
    CoUninitialize;

  end;
  if FWorkMode = wmManGetLinksToDb then
  begin
    FErrorLog.SaveToFile(FErrorLogFile);
    FErrorLog.Free;
  end;

  inherited Destroy;
end;

procedure TDTManager.Execute;
var
  i: Integer;
begin

  if Ftest then
    while not Terminated do
      for i := 0 to 25 do
        Self.State := (TDTManState(i));

  // Exit;
  case FWorkMode of
    wmManGetStudentsToFiles, wmManGetStudentsToDB:
      GetListsOfRefsOnMastersPortal;
    wmManGetLinksToFile, wmManGetLinksToDb:
      begin
        CoInitialize(nil);
        FADOQuery := TADOquery.Create(nil);
        MakeBAK;
        GetData;
      end;

  end;

end;

procedure TDTManager.FreeResource;
begin
  FDictionaryArray := nil;
  FMD5ListArray := nil;
  FDTArray := nil;
  FDTStatesCurrent := nil;
  FDTStatesBuffered := nil;
end;

procedure TDTManager.GetData;

var
  i, j, k: Integer;
  buf1, buf2, buf3: Integer;

  Indexinlist: Integer;
  bufflag: Boolean;

  M, m1: Integer;
  l: Integer;

begin

  FBigDictionary := TLinkDictionary.Create;
  FBigMD5List := TMD5List.Create;

  AllocateResource(FMaxThreads);
  try
    buf1 := FStudRefsRemainList.Count div FMaxThreads;
    buf2 := FStudRefsRemainList.Count mod FMaxThreads;
    M := 0;
    m1 := FStudRefsRemainList.Count; // buf1 * FMaxThreads;

    Self.State := dtmsGetLinksStart;
    if buf1 = 0 then
      buf3 := buf2
    else
      buf3 := FMaxThreads;

    for j := 0 to buf3 - 1 do
    begin
      FDictionaryArray[j] := TLinkDictionary.Create;
      FMD5ListArray[j] := TMD5List.Create;
      FDTArray[j] := TDownloadThread.Create(False, FDictionaryArray[j],
        FMD5ListArray[j], FStudRefsRemainList[0], j, @FDTStatesCurrent[j],
        wmFullProc);
      // FStudRefsProcessedList.Add(FStudRefsRemainList[0]);
      FStudRefsRemainList.Delete(0);
      inc(M);
    end;

    Self.State := dtmsWaitingForThreadsStart;
    bufflag := true;
    while bufflag { FStudRefsRemainList.Count > 0 } do
    begin
      for i := 0 to buf3 - 1 do
        if IsDTStatesChanged(i) then
        begin
          FDTStatesBuffered[i] := FDTStatesCurrent[i];
          if Assigned(FOnDTStatesChange) then
            FOnDTStatesChange(FDTStatesBuffered[i]);
        end;
      for i := 0 to buf3 - 1 do
        if FDTStatesBuffered[i].FLinksWaitNumber <> 0 then
          Continue
        else
        begin
          for k := 0 to FDTStatesCurrent[i].LinksNumber - 1 do
          begin
            FBigDictionary.Add(FDictionaryArray[i].Values.ToArray[k]
              .HashValue.Current, FDictionaryArray[i].Values.ToArray[k]);
          end;
          for k := 0 to FDTStatesCurrent[i].FLinksInHashList - 1 do
            FBigMD5List.Add(FMD5ListArray[i][k]);

          FDictionaryArray[i].Free;
          FMD5ListArray[i].Free;

          // FStudRefsRemainList.Find(FDTStatesCurrent[i].StartRef, Indexinlist);
          // FStudRefsRemainList.Delete(Indexinlist);
          FStudRefsProcessedList.Add(FDTStatesCurrent[i].StartRef);
          if FStudRefsProcessedList.Count = m1 then
            bufflag := False;

          FDTStatesCurrent[i].FLinksWaitNumber := 1;
          FDTStatesBuffered[i].FLinksWaitNumber := 1;
          // if FStudRefsRemainList.Count = 0 then
          // Break;
          if M <> m1 then
          begin
            FDictionaryArray[i] := TLinkDictionary.Create;
            FMD5ListArray[i] := TMD5List.Create;
            FDTArray[i] := TDownloadThread.Create(False, FDictionaryArray[i],
              FMD5ListArray[i], FStudRefsRemainList[0], i, @FDTStatesCurrent[i],
              wmFullProc);
            FStudRefsRemainList.Delete(0);
            inc(M);
          end;
          LoadToDB(3);
          Self.State := dtmsWriteLinksToFileStart;
          FStudRefsRemainList.SaveToFile(FStudFileRemain);
          FStudRefsProcessedList.SaveToFile(FStudFileProcessed);
          FErrorLog.SaveToFile(FErrorLogFile);
          Self.State := dtmsWriteLinksToFileFinish;
          MakeBAK;
          FBigDictionary.Clear;
          FBigMD5List.Clear;
        end;
      Sleep(FInterval);
    end;
    Self.State := dtmsWaitingForThreadsFinish;

    Self.State := dtmsGetLinksFinish;
  finally
    LoadToDB(3);
    Self.State := dtmsWriteLinksToFileStart;
    FStudRefsRemainList.SaveToFile(FStudFileRemain);
    FErrorLog.SaveToFile(FErrorLogFile);
    FStudRefsProcessedList.SaveToFile(FStudFileProcessed);
    Self.State := dtmsWriteLinksToFileFinish;
    MakeBAK;
    FBigDictionary.Free;
    FBigMD5List.Free;

    FStudRefsRemainList.Free;
    FStudRefsProcessedList.Free;
    FreeResource;
  end;

end;

function TDTManager.GetDocName(AYear: Integer): string;
begin
  if (AYear >= 2000) and (AYear <= 2008) then
    Exit('http://masters.donntu.edu.ua/' + inttostr(AYear) + '/index.html');
  if (AYear >= 2009) and (AYear <= 2011) then
    Exit('http://masters.donntu.edu.ua/' + inttostr(AYear) + '/index.htm')
end;

function TDTManager.GetIDFromMD5(AField, ATAble, AMD5Field, AMD5Value,
  ADefault: String): string;
begin
  with FADOQuery do
  begin
    Close;
    SQL.Clear;
    SQL.Add(Format(ADO_GET_ID_FROM_MD5, [AField, ATAble, AMD5Field,
      AMD5Value]));
    Open;
    Result := FieldList.Fields[0].AsString;
    if Result = '' then
      Result := ADefault;
    Close;
    SQL.Clear;
  end;

end;

procedure TDTManager.GetListsOfRefsOnMastersPortal;
var
  i, j, k, M, l: Integer;
  buf1, buf2: Integer;

  bufRefsList: TStringList;

  bufMd51: TInfoMD5;
  bufMd52: TInfoMD5;
  bufMd53: TInfoMD5;

begin
  AllocateResource(12);
  if FWorkMode = wmManGetStudentsToDB then
  begin
    FBigDictionary := TLinkDictionary.Create;
    CoInitialize(nil);
    InitializeDB;
    // FBigMD5List:=TMD5List.Create;
  end;

  FFacsRefsList := TStringList.Create;
  FStudRefsList := TStringList.Create;
  bufRefsList := TStringList.Create;
  FStudRefsList.Sorted := true;
  FStudRefsList.Duplicates := dupIgnore;

  Self.State := dtmsGetFacsLinksStart;
  //  
  for i := 0 to 11 do
  begin
    FDictionaryArray[i] := TLinkDictionary.Create;
    FMD5ListArray[i] := TMD5List.Create;
    FDTArray[i] := TDownloadThread.Create(False, FDictionaryArray[i],
      FMD5ListArray[i], GetDocName(2000 + i), i, @FDTStatesCurrent[i],
      wmOnePage);
  end;

  Self.WaitForThreads(12);

  //         
  for i := 0 to 11 do
    if FWorkMode = wmManGetStudentsToDB then
    begin
      for j := 0 to FDTStatesCurrent[i].LinksNumber - 1 do
      begin
        FFacsRefsList.Add(FDictionaryArray[i].Values.ToArray[j].Connection.Url);
        FBigDictionary.Add(FDictionaryArray[i].Values.ToArray[j]
          .HashValue.Current, FDictionaryArray[i].Values.ToArray[j]);
        // FBigMD5List.Add(FMD5ListArray[i][j])
      end;
      FDictionaryArray[i].Free;
      FMD5ListArray[i].Free;

    end
    else
    begin
      for j := 0 to FDTStatesCurrent[i].LinksNumber - 1 do
        FFacsRefsList.Add(FDictionaryArray[i].Values.ToArray[j].Connection.Url);
      FDictionaryArray[i].Free;
      FMD5ListArray[i].Free;
    end;

  //    ,     
  //    .   
  FFacsRefsList.Add('http://masters.donntu.edu.ua/2007/fem/index.html');
  FFacsRefsList.Add('http://masters.donntu.edu.ua/2008/fem/index.html');

  if FWorkMode = wmManGetStudentsToDB then
  begin
    bufMd51 := TInfoMD5.Create
      ('http://masters.donntu.edu.ua/2007/fem/index.html',
      'http://masters.donntu.edu.ua/2007/index.html');
    bufMd52 := TInfoMD5.Create
      ('http://masters.donntu.edu.ua/2008/fem/index.html',
      'http://masters.donntu.edu.ua/2008/index.html');
  end;


  //     ,      
  //  ,     .
  //   .

  // for bufstr in FFacsRefsList do                  //-  
  // if not IsCorrectFacultyRef(bufstr) then        // .   
  // begin
  // FFacsRefsList.Delete(FFacsRefsList.IndexOf(bufstr));
  // CodeSite.SendError(' ' + bufstr);
  // end;

  for i := 0 to FFacsRefsList.Count - 1 do
    if not IsCorrectFacultyRef(FFacsRefsList[i]) then
      bufRefsList.Add(FFacsRefsList[i]);
  for i := 0 to bufRefsList.Count - 1 do
    if FWorkMode = wmManGetStudentsToDB then
    begin
      bufMd53 := TInfoMD5.Create(bufRefsList[i], '');
      FBigDictionary.Remove(bufMd53.Current);
      FFacsRefsList.Delete(FFacsRefsList.IndexOf(bufRefsList[i]));
    end
    else
      FFacsRefsList.Delete(FFacsRefsList.IndexOf(bufRefsList[i]));
  Self.State := dtmsGetFacsLinksFinish;
  bufRefsList.Clear;
  Self.State := dtmsWriteFacsLinksToFileStart;
  //    
  FFacsRefsList.SaveToFile(FFacsFile);
  Self.State := dtmsWriteFacsLinksToFileFinish;
  //     
  if FWorkMode = wmManGetStudentsToDB then
  begin
    LoadToDB(0); //    
    LoadToDB(1); //    
    // +   
    LoadToDB('http://masters.donntu.edu.ua/2007/fem/index.html', bufMd51, 2007);
    LoadToDB('http://masters.donntu.edu.ua/2008/fem/index.html', bufMd52, 2008);
    FBigDictionary.Clear;
  end;

  buf1 := FFacsRefsList.Count div FMaxThreads;
  buf2 := FFacsRefsList.Count mod FMaxThreads;

  //   
  Self.FreeResource;
  Self.AllocateResource(FMaxThreads);
  M := 0;
  Self.State := dtmsGetStudLinksStart;
  //  
  for i := 0 to buf1 - 1 do
  begin
    for j := 0 to FMaxThreads - 1 do
    begin
      FDictionaryArray[j] := TLinkDictionary.Create;
      FMD5ListArray[j] := TMD5List.Create;
      FDTArray[j] := TDownloadThread.Create(False, FDictionaryArray[j],
        FMD5ListArray[j], FFacsRefsList[M], j, @FDTStatesCurrent[j], wmOnePage);
      inc(M);
    end;

    WaitForThreads(FMaxThreads);

    //         
    for j := 0 to (FMaxThreads - 1) do
    begin
      if FWorkMode = wmManGetStudentsToDB then
        for k := 0 to FDTStatesCurrent[j].LinksNumber - 1 do
        begin
          FStudRefsList.Add(FDictionaryArray[j].Values.ToArray[k]
            .Connection.Url);
          if not FBigDictionary.ContainsKey(FDictionaryArray[j].Values.ToArray
            [k].HashValue.Current) then
            FBigDictionary.Add(FDictionaryArray[j].Values.ToArray[k]
              .HashValue.Current, FDictionaryArray[j].Values.ToArray[k])
          else
            { CodeSite.SendError(FDictionaryArray[j].Values.ToArray[k]
              .Connection.Url + ' ###### ' + inttostr(M)); }
        end
      else
        for k := 0 to FDTStatesCurrent[j].LinksNumber - 1 do
        begin
          FStudRefsList.Add(FDictionaryArray[j].Values.ToArray[k]
            .Connection.Url);

        end;
      FDictionaryArray[j].Free;
      FMD5ListArray[j].Free;
    end;
    FDTStatesCurrent := nil;
    FDTStatesBuffered := nil;
    SetLength(FDTStatesCurrent, FMaxThreads);
    SetLength(FDTStatesBuffered, FMaxThreads);
  end;

  FreeResource;
  AllocateResource(buf2);

  for i := 0 to buf2 - 1 do
  begin
    FDictionaryArray[i] := TLinkDictionary.Create;
    FMD5ListArray[i] := TMD5List.Create;
    FDTArray[i] := TDownloadThread.Create(False, FDictionaryArray[i],
      FMD5ListArray[i], FFacsRefsList[M], i, @FDTStatesCurrent[i], wmOnePage);
    inc(M);
  end;

  WaitForThreads(buf2);

  for i := 0 to buf2 - 1 do
  begin
    if FWorkMode = wmManGetStudentsToDB then
      for j := 0 to FDTStatesCurrent[i].LinksNumber - 1 do
      begin
        FStudRefsList.Add(FDictionaryArray[i].Values.ToArray[j].Connection.Url);
        if not FBigDictionary.ContainsKey(FDictionaryArray[i].Values.ToArray[j]
          .HashValue.Current) then

          FBigDictionary.Add(FDictionaryArray[i].Values.ToArray[j]
            .HashValue.Current, FDictionaryArray[i].Values.ToArray[j])
          { else
            CodeSite.SendError(FDictionaryArray[i].Values.ToArray[j]
            .Connection.Url + ' ###### ' + inttostr(M)); }
      end

    else
      for j := 0 to FDTStatesCurrent[i].LinksNumber - 1 do
      begin
        FStudRefsList.Add(FDictionaryArray[i].Values.ToArray[j].Connection.Url);
      end;
    FDictionaryArray[i].Free;
    FMD5ListArray[i].Free;
  end;
  Self.State := dtmsGetStudLinksFinish;
  //       

  // for bufstr in FStudRefsList do
  // if not IsCorrectStudentRef(bufstr) then
  // begin
  // FStudRefsList.Delete(FStudRefsList.IndexOf(bufstr));
  // CodeSite.SendError(' ' + bufstr);
  // end;

  for i := 0 to FStudRefsList.Count - 1 do
    if not IsCorrectStudentRef(FStudRefsList[i]) then
      bufRefsList.Add(FStudRefsList[i]);
  for i := 0 to bufRefsList.Count - 1 do
    if FWorkMode = wmManGetStudentsToDB then
    begin
      FStudRefsList.Delete(FStudRefsList.IndexOf(bufRefsList[i]));
      bufMd53 := TInfoMD5.Create(bufRefsList[i], '');
      FBigDictionary.Remove(bufMd53.Current);
    end
    else
      FStudRefsList.Delete(FStudRefsList.IndexOf(bufRefsList[i]));

  bufRefsList.Clear;
  Self.State := dtmsWriteStudLinksToFileStart;
  FStudRefsList.SaveToFile(FStudFile);
  Self.State := dtmsWriteStudLinksToFileFinish;
  if FWorkMode = wmManGetStudentsToDB then
  begin
    LoadToDB(2);
    FBigDictionary.Free;
  end;

  FFacsRefsList.Free;
  FStudRefsList.Free;
  bufRefsList.Free;
  FreeResource;

end;

procedure TDTManager.InitializeDB;
var
  cat: OLEVariant;
begin
  Self.State := dtmsCreatingDBStart;
  If FileExists(FDBFile) Then
    deleteFile(FDBFile);
  try
    cat := CreateOleObject('ADOX.Catalog');
    cat.Create(Format(ADO_CREATE_STRING, [FDBFile]));
    variantclear(cat);
    with FADOQuery do
    begin
      Close;
      SQL.Clear;
      ConnectionString := Format(ADO_CONNECTION_STRING, [FDBFile]);
      SQL.Add(ADO_CREATE_YEARS_TABLE);
      ExecSQL;
      SQL.Clear;
      SQL.Add(ADO_CREATE_FACULTIES_TABLE);
      ExecSQL;
      SQL.Clear;
      SQL.Add(ADO_CREATE_STUDENTS_TABLE);
      ExecSQL;
      SQL.Clear;
      SQL.Add(ADO_CREATE_REFS_TABLE);
      ExecSQL;
      SQL.Clear;
      SQL.Add(ADO_CREATE_CROSSREFS_TABLE);
      ExecSQL;
    end;
    Self.State := dtmsCreatingDBFinish;
  except
    on E: Exception do
      raise EDTManProblemWithADOX.Create('ADOX  cant create new DataBase');
  end;

end;

function TDTManager.IsCorrectFacultyRef(ARef: string): Boolean;
begin
  with FRegExprFacultyRef do
  begin
    Subject := ARef;
    Result := Match;
    Subject := '';
  end;
end;

function TDTManager.IsCorrectStudentRef(ARef: string): Boolean;
begin
  with FRegExprStudentRef do
  begin
    Subject := ARef;
    Result := Match;
    Subject := '';
  end;
end;

function TDTManager.IsDTStatesChanged(index: Integer): Boolean;
begin
  with FDTStatesCurrent[index] do
  begin
    if LinksNumber <> FDTStatesBuffered[index].LinksNumber then
      Exit(true);
    if LinksWaitNumber <> FDTStatesBuffered[index].LinksWaitNumber then
      Exit(true);
    if LinksInHashList <> FDTStatesBuffered[index].LinksInHashList then
      Exit(true);
  end;
  Exit(False);

end;

procedure TDTManager.LoadToDB(AURL: string; AMD5: TInfoMD5; AYear: Integer);
begin
  with FADOQuery do
  begin
    SQL.Clear;
    SQL.Add(Format(ADO_ADD_FACULTY, [AURL, inttostr(AYear), AMD5.Current]));
    ExecSQL;
    SQL.Clear;
  end;
end;

function TDTManager.RefIsUnique(AMD5: String): Boolean;
begin
  with FADOQuery do
  begin
    Close;
    SQL.Clear;
    SQL.Add(Format(ADO_IS_REF_UNUQUE, [AMD5]));
    Open;
    Result := ((FieldList[0].AsInteger) = 0);
    Close;
    SQL.Clear;
  end;
end;

procedure TDTManager.LoadToDB(AInt: Integer);
var
  i: Integer;
  buf1, buf2: string;
begin
  case AInt of
    0:
      begin
        Self.State := dtmsWriteYearsLinkstoDBStart;
        for i := 2000 to 2011 do
          with FADOQuery do
          begin
            if Assigned(FLoadTODbNotifier) then
              FLoadTODbNotifier('T_Years', 12, i - 1999);
            SQL.Clear;
            SQL.Add(Format(ADO_ADD_YEARS, [i, GetDocName(i)]));
            ExecSQL;
            SQL.Clear;
          end;
        Self.State := dtmsWriteYearsLinkstoDBFinish;
      end;

    1:
      begin
        Self.State := dtmsWriteFacsLinksToDbStart;
        for i := 0 to FBigDictionary.Count - 1 do
          with FADOQuery do
            with FBigDictionary.Values.ToArray[i] do
            begin
              if Assigned(FLoadTODbNotifier) then
                FLoadTODbNotifier('TFaculties', FBigDictionary.Count, i + 1);
              SQL.Clear;
              SQL.Add(Format(ADO_ADD_FACULTY, [Connection.Url, Student.RelYear,
                HashValue.Current]));
              ExecSQL;
              SQL.Clear;
            end;
        Self.State := dtmsWriteFacsLinksToDbFinish;
      end;
    2:
      begin
        Self.State := dtmsWriteStudLinksToDBStart;
        for i := 0 to FBigDictionary.Count - 1 do
          with FADOQuery do
            with FBigDictionary.Values.ToArray[i] do
            begin
              if Assigned(FLoadTODbNotifier) then
                FLoadTODbNotifier('T_Students', FBigDictionary.Count, i + 1);
              SQL.Clear;
              SQL.Add(Format(ADO_ADD_STUDENT, [Connection.Url, Student.RelYear,
                Self.GetIDFromMD5('Faculty_ID', 'TFaculties', 'Faculty_MD5',
                HashValue.StartRef, 'VASYA'), HashValue.Current]));
              /// //////
              ExecSQL;
            end;
        FADOQuery.SQL.Clear;
        Self.State := dtmsWriteStudLinksToDBFinish;
      end;
    3:
      begin
        Self.State := dtmsWriteLinksToDBStart;
        with FADOQuery do
        begin
          for i := 0 to FBigDictionary.Count - 1 do
            with FBigDictionary.Values do
            begin
              if RefIsUnique(ToArray[i].HashValue.Current) then
              begin
                try
                  if Assigned(FLoadTODbNotifier) then
                    FLoadTODbNotifier('TRefs', FBigDictionary.Count, i + 1);
                  { CodeSite.SendError('sssss' + SQL.Text); }
                  SQL.Clear;
                  buf1 := ToArray[i].ToString;
                  { CodeSite.SendError(buf1); }
                  SQL.Add(Format(buf1, [GetIDFromMD5('Student_ID', 'TStudents',
                    'Student_MD5', ToArray[i].HashValue.StartRef, 'VASYA')]));
                  { CodeSite.SendError(SQL.Text + '1234567'); }
                  /// //////
                  ExecSQL;
                except
                  on E: Exception do
                  begin
                    SendError('Error: ' + E.ClassName + '; Message:' + E.Message
                      + '; SQL: ' + SQL.Text + '.');
                    { CodeSite.SendError(SQL.Text); }
                  end;
                end;
              end;
            end;
          with FBigMD5List do
            for i := 0 to Count - 1 do
              with Items[i] do
              begin
                try
                  if Assigned(FLoadTODbNotifier) then
                    FLoadTODbNotifier('TCrossRefs', FBigMD5List.Count, i + 1);
                  SQL.Clear;
                  buf1 := GetIDFromMD5('Ref_ID', 'TRefs', 'Ref_MD5',
                    Parent, '-10');
                  buf2 := GetIDFromMD5('Ref_ID', 'TRefs', 'Ref_MD5',
                    Current, '-10');
                  if (buf1 = '-10') and (buf2 = '-10') then
                    Continue;
                  SQL.Add(Format(ADO_ADD_CROSS,
                    [buf1, buf2, GetIDFromMD5('Student_ID', 'TStudents',
                    'Student_MD5', StartRef, 'VASYA')]));
                  ExecSQL;
                except
                  on E: Exception do
                    SendError('Error: ' + E.ClassName + '; Message:' + E.Message
                      + '; SQL: ' + SQL.Text + '.');
                end;
              end;
        end;
        Self.State := dtmsWriteLinksToDBFinish;
      end;
  end;

end;

procedure TDTManager.SendError(AMes: String);
begin
  Self.FErrorLog.Add(AMes);
  if Assigned(FErrorNotifier) then
    FErrorNotifier(AMes);

end;

procedure TDTManager.SetState(ADTManState: TDTManState);
begin
  Self.FDTManState := ADTManState;
  if Assigned(FOnDTManagerStateChangeEvent) then
    case ADTManState of
      dtmsGetFacsLinksStart:
        FOnDTManagerStateChangeEvent(ADTManState,
          ['   .']);
      dtmsGetFacsLinksFinish:
        FOnDTManagerStateChangeEvent(ADTManState,
          ['   .', FFacsRefsList.Count]);
      dtmsGetLinksStart:
        FOnDTManagerStateChangeEvent(ADTManState,
          ['    .']);
      dtmsGetLinksFinish:
        FOnDTManagerStateChangeEvent(ADTManState,
          ['     .', FBigDictionary.Count,
          FBigMD5List.Count]);
      dtmsWriteLinksToFileStart:
        FOnDTManagerStateChangeEvent(ADTManState,
          ['   ..', FStudRefsRemainList,
          FStudRefsProcessedList]);
      dtmsGetStudLinksStart:
        FOnDTManagerStateChangeEvent(ADTManState,
          ['    .']);
      dtmsGetStudLinksFinish:
        FOnDTManagerStateChangeEvent(ADTManState,
          ['    .']);
      dtmsMakeBackupStart:
        FOnDTManagerStateChangeEvent(ADTManState, ['..']);
      dtmsMakeBackupFinish:
        FOnDTManagerStateChangeEvent(ADTManState, ['..']);
      dtmsWaitingForThreadsStart:
        FOnDTManagerStateChangeEvent(ADTManState, ['  .',
          Length(FDTArray)]);
      dtmsWaitingForThreadsFinish:
        FOnDTManagerStateChangeEvent(ADTManState, ['  .']);
      dtmsWriteFacsLinksToDbStart:
        FOnDTManagerStateChangeEvent(ADTManState,
          ['      ..']);
      dtmsWriteFacsLinksToDbFinish:
        FOnDTManagerStateChangeEvent(ADTManState,
          ['      ..']);
      dtmsWriteFacsLinksToFileStart:
        FOnDTManagerStateChangeEvent(ADTManState,
          ['     ..']);
      dtmsWriteFacsLinksToFileFinish:
        FOnDTManagerStateChangeEvent(ADTManState,
          ['     ..']);
      dtmsWriteLinksToDBFinish:
        FOnDTManagerStateChangeEvent(ADTManState,
          ['    ..']);
      dtmsCreatingDBStart:
        FOnDTManagerStateChangeEvent(ADTManState,
          ['  ..']);
      dtmsCreatingDBFinish:
        FOnDTManagerStateChangeEvent(ADTManState,
          ['  ..']);
      dtmsWriteLinksToFileFinish:
        FOnDTManagerStateChangeEvent(ADTManState,
          ['   .']);
      dtmsWriteLinksToDBStart:
        FOnDTManagerStateChangeEvent(ADTManState,
          ['    ..']);
      dtmsWriteStudLinksToDBStart:
        FOnDTManagerStateChangeEvent(ADTManState,
          ['       ..']);
      dtmsWriteStudLinksToDBFinish:
        FOnDTManagerStateChangeEvent(ADTManState,
          ['       ..']);
      dtmsWriteStudLinksToFileStart:
        FOnDTManagerStateChangeEvent(ADTManState,
          ['      ..']);
      dtmsWriteStudLinksToFileFinish:
        FOnDTManagerStateChangeEvent(ADTManState,
          ['      ..']);
      dtmsWriteYearsLinkstoDBStart:
        FOnDTManagerStateChangeEvent(ADTManState,
          ['        ..']
          );
      dtmsWriteYearsLinkstoDBFinish:
        FOnDTManagerStateChangeEvent(ADTManState,
          ['        ..']
          );
    end;
end;

procedure TDTManager.WaitForThreads(ACount: Integer);
var
  i: Integer;
  bufflag: Boolean;

begin
  Self.State := dtmsWaitingForThreadsStart;
  bufflag := true;
  while bufflag do
  begin
    for i := 0 to ACount - 1 do
      if IsDTStatesChanged(i) then
      begin
        FDTStatesBuffered[i] := FDTStatesCurrent[i];
        if Assigned(FOnDTStatesChange) then
          FOnDTStatesChange(FDTStatesBuffered[i]);
      end;
    for i := 0 to ACount - 1 do
      if FDTStatesBuffered[i].FLinksWaitNumber <> 0 then
        Break
      else if i = ACount - 1 then
        bufflag := False;
    Sleep(FInterval);
  end;

  Self.State := dtmsWaitingForThreadsFinish;

end;

initialization

Randomize;

end.
