unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DTUnit, StdCtrls, ComObj, DB, Data.Win.adodb, Vcl.Grids, Vcl.ValEdit,
  OKCANCL2, Vcl.ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    ValueListEditor1: TValueListEditor;
    ValueListEditor2: TValueListEditor;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ListBox1: TListBox;
    ListBox2: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    StringGrid1: TStringGrid;
    StatusBar1: TStatusBar;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }

  public
    procedure TerminateMan(Sender: TObject);
    procedure DTStatesChangeEvent(ADTState: TDTState);
    procedure StateChangeEvent(ADTManState: TDTManState;
      AParams: array of const);
    procedure Workwithbase(ATAble: String; Aall, ACurrent: Integer);
    procedure ErrorNotifier(AMes: String);
    { Public declarations }
  end;

var
  form1: TForm1;
  DThreadMan: TDTManager;
  Errorcount: Integer;
  Messagecount: Integer;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  i: Integer;
begin
  if Assigned(DThreadMan) then
  begin
    DThreadMan.Terminate;
    Exit;
  end;
  with OKRightDlg do
  begin
    ShowModal;
    if threadNumber = 0 then
      Exit;
    ValueListEditor2.Values['  .mdb'] := FileName;
    if isnew then
    begin
      DThreadMan := TDTManager.Create(true, threadNumber, 500, FileName);
      for i := 2 to 6 do
        ValueListEditor2.Cells[1, i] := '';

    end
    else
    begin
      DThreadMan := TDTManager.Create(true, FileName, threadNumber, 100);
      ValueListEditor2.Cells[1, 2] := DThreadMan.StudFileProcessed;
      ValueListEditor2.Cells[1, 3] := DThreadMan.StudFileRemain;
      ValueListEditor2.Cells[1, 4] := DThreadMan.ErrorLogFile;
      ValueListEditor2.Cells[1, 5] := '';
      ValueListEditor2.Cells[1, 6] := '';

    end;
  end;

  DThreadMan.OnDTStatesChange := Self.DTStatesChangeEvent;
  DThreadMan.OnDTManagerStateChangeEvent := Self.StateChangeEvent;
  DThreadMan.ErrorNotifier := Self.ErrorNotifier;
  DThreadMan.OnTerminate := Self.TerminateMan;
  DThreadMan.DBNotifier := Self.Workwithbase;
  DThreadMan.Start;

end;

procedure TForm1.DTStatesChangeEvent(ADTState: TDTState);
begin
  with StringGrid1 do
    with ADTState do
    begin
      Cells[0, MyID + 1] := IntToStr(MyID);
      Cells[1, MyID + 1] := IntToStr(LinksNumber);
      if LinksWaitNumber <> 0 then
        Cells[2, MyID + 1] := IntToStr(LinksWaitNumber)
      else
        Cells[2, MyID + 1] := '';
      Cells[3, MyID + 1] := IntToStr(LinksInHashList);
      Cells[4, MyID + 1] := StartRef
    end;
end;

procedure TForm1.ErrorNotifier(AMes: String);
begin
  Inc(Errorcount);
  Memo1.Lines.Add(IntToStr(Errorcount) +
    ': !<>!<>!<>!<>ERROR<>!<>!<>!<>! ' + AMes);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Memo1.Lines.SaveToFile('Mylog.txt');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  StringGrid1.Rows[0].Add(' ');
  StringGrid1.Rows[0].Add('  ');
  StringGrid1.Rows[0].Add(' ');
  StringGrid1.Rows[0].Add('  ');
  StringGrid1.Rows[0].Add(' ');
  StringGrid1.ColWidths[4] := 200;
end;

procedure TForm1.StateChangeEvent(ADTManState: TDTManState;
  AParams: array of const);
var
  buf: string;
begin
  Inc(Messagecount);
  buf := IntToStr(Messagecount) + ': <<<<<Service>>>>> ' +
    string(AParams[0].VUnicodeString);
  ValueListEditor1.Cells[1, 1] := IntToStr(Integer(ADTManState));
  case ADTManState of
    dtmsWaitingForThreadsStart:
      begin
        StringGrid1.RowCount := AParams[1].VInteger + 1;
        ValueListEditor1.Cells[1, 2] := IntToStr(AParams[1].VInteger);
      end;
    dtmsGetLinksFinish:
      begin
        buf := buf + '   ' + IntToStr(AParams[1].VInteger) +
          '  ;   ' + IntToStr(AParams[2].VInteger) + ' ';
      end;
    dtmsWriteLinksToFileStart:
      begin
        buf := buf + '  ' +
          IntToStr((AParams[1].VObject as TStringList).Count) +
          ';   ' +
          IntToStr((AParams[2].VObject as TStringList).Count);
//        ListBox1.Items := (AParams[1].VObject as TStringList);
//        ListBox2.Items := (AParams[2].VObject as TStringList);
        ValueListEditor1.Cells[1, 3] :=
          IntToStr((AParams[2].VObject as TStringList).Count);
        ValueListEditor1.Cells[1, 4] :=
          IntToStr((AParams[1].VObject as TStringList).Count);
      end;
    dtmsGetFacsLinksFinish:
      buf := buf + '  ' + IntToStr(AParams[1].VInteger);

  end;
  Memo1.Lines.Add(buf);
end;

procedure TForm1.TerminateMan(Sender: TObject);
begin
  Inc(Messagecount);
  Memo1.Lines.Add(IntToStr(Messagecount) +
    ': <<<<<Service>>>>>  ');
  ValueListEditor1.Cells[1, 1] := '';
end;

procedure TForm1.Workwithbase(ATAble: String; Aall, ACurrent: Integer);
begin
  StatusBar1.Panels[2].Text := ATAble;
  StatusBar1.Panels[4].Text := IntToStr(ACurrent);
  StatusBar1.Panels[5].Text := IntToStr(Aall);

end;

initialization

Errorcount := 0;
Messagecount := 0;

// System.ReportMemoryLeaksOnShutdown:=True;
finalization

// DThreadMan.Free;

end.
